<?php
/**************** myFtpWebEdit **********************************************************************************
Author: 	Stefan Bracher www.bracher-automation.com
Date: 		14.06.2010	
Licence: 	GNU General Public License (GPL), please refer redme
***************************************************************************************************************/

/******* Settings *********************************************************************************************/
$ftp_server=$_SERVER['SERVER_ADDR'];					// The ftp server we are running on
$ftp_root="www";							// The ftp root
$ftp_folder="www/content/";						// The ftp content-folder
$serverclass="";
$userpass="";
$folderclass="";
/**************************************************************************************************************/

/******* Functions ********************************************************************************************/
function htmlconf($text)
{
// General: Replacing general php-related problems: "'/"
$search=array("/(\\\\)/", "/\"/", "/&lt;/", "/&gt;/");
$replace=array("", "&quot;", "<", ">");
$text2=preg_replace($search, $replace, $text);

// German Characters: Replacing German Characters
$search=array("/ä/", "/ö/", "/ü/", "/Ä/", "/Ö/","/Ü/", "/ß/");
$replace=array("&auml;", "&ouml;", "&uuml;", "&Auml;", "&Ouml;", "&Uuml;", "&szlig;");
$text2=preg_replace($search, $replace, $text2);

// French and Italian Caracters
$search=array("/à/","/è/","/é/","/ê/","/î/","/ô/","/ç/","/û/");
$replace=array("&agrave;", "&egrave;", "&eacute;", "&ecirc;", "&icirc;", "&ocirc;", "&ccedil;", "&ucirc;");
$text2=preg_replace($search, $replace, $text2);

// Portuguese and Spanish caracters
$search=array("/ã/", "/Â/","/ñ/", "/õ/", "/á/", "/í/", "/ó/", "/ú/");
$replace=array("&atilde;", "&Atilde;", "&ntilde;", "&otilde;", "&aacute;", "&iacute;", "&oacute;", "&uacute;");
$text2=preg_replace($search, $replace, $text2);
return($text2);
}
/**************************************************************************************************************/

/******** Session Start ***************************************************************************************/
session_start();								// Create a new one
 if ((!(isset($_SESSION['time']))) or (array_key_exists('logout',$_GET)))	// New user or logout request
 	{ 
	$_SESSION['time']= date('l F jS, Y G:i:s T');
 	$_SESSION['user']= "";
	$_SESSION['password']= "";
 	$_SESSION['logged_in']= "no";
 	}
/**************************************************************************************************************/

/******** Login attempt **************************************************************************************/
if (array_key_exists('password',$_POST))					// Login request
	{
	$_SESSION['user']= $_POST['user'];
	$_SESSION['password']= $_POST['password'];
	
	$ftpstream = @ftp_connect($ftp_server);					// Connect to server
	if ($ftpstream)
		{									// Server correct
		$login = @ftp_login($ftpstream, $_SESSION['user'], $_SESSION['password']);	// Login
		if($login) 								// If successfully logged in 
			{							
											//We are now connected to FTP server.
				if (ftp_nlist($ftpstream ,  $ftp_folder))	// List folder
					{
					$_SESSION['logged_in']= "yes";
					}
			
			} 
		else	{ $userpass="class=\"red\"";}
		@ftp_close($ftpstream);	
		}
	else	{ $serverclass="class=\"red\"";}
	}
/**************************************************************************************************************/

/*************************HTML HEAD**************************************************************************/?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta name="author" content="Bracher-Automation www.bracher-automation.com" />
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title>myFtpWebEdit</title>
<link href="files/style.php" rel="stylesheet" type="text/css" />
<link href="favicon.ico" rel="SHORTCUT ICON" />
<?php // -------------------- Javascript ------------------------------------------------------------------?>
<script type="text/javascript" src="files/tiny_mce/tiny_mce.js"></script>
<script type="text/javascript">
	tinyMCE.init({
		// General options
		mode : "textareas",
		theme : "advanced",
		plugins : "pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,wordcount,advlist,autosave",

		// Theme options
		theme_advanced_buttons1 : "save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,styleselect,formatselect,fontselect,fontsizeselect",
		theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,insertdate,inserttime,preview,|,forecolor,backcolor",
		theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,iespell,media,advhr,|,print,|,ltr,rtl,|,fullscreen",
		theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,template,pagebreak,restoredraft",
		theme_advanced_toolbar_location : "top",
		theme_advanced_toolbar_align : "left",
		theme_advanced_statusbar_location : "bottom",
		theme_advanced_resizing : true,

		// Example content CSS (should be your site CSS)
		content_css : "../css/style.php",

		// Drop lists for link/image/media/template dialogs
		template_external_list_url : "lists/template_list.js",
		external_link_list_url : "lists/link_list.js",
		external_image_list_url : "lists/image_list.js",
		media_external_list_url : "lists/media_list.js",

		// Style formats
		style_formats : [
			{title : 'Bold text', inline : 'b'},
			{title : 'Red text', inline : 'span', styles : {color : '#ff0000'}},
			{title : 'Red header', block : 'h1', styles : {color : '#ff0000'}},
			{title : 'Example 1', inline : 'span', classes : 'example1'},
			{title : 'Example 2', inline : 'span', classes : 'example2'},
			{title : 'Table styles'},
			{title : 'Table row 1', selector : 'tr', classes : 'tablerow1'}
		],

		// Replace values for the template plugin
		template_replace_values : {
			username : "none",
			staffid : "1111"
		}
	});
</script> 
</head>
<?php /**************************************************************************************************************

/*************************HTML BODY*********************************************************************************/?>
<body>
<?php 
// -------------------- Not Logged in ----------------------------------------------------------------------------------
if ($_SESSION['logged_in']=="no")
	{
	echo "<div id=\"login\">";
	echo "<form action=\"$_SERVER[PHP_SELF]\" method=\"POST\">";
	echo "<table>\n";
	echo "<tr><td><img src=\"files/tango_icons/user.png\" alt=\"User\" /></td><td><input type=\"text\" name=\"user\" size=\"30\"  value=\"$_SESSION[user]\" $userpass/></td></tr>\n";
	echo "<tr><td><img src=\"files/tango_icons/password.png\" alt=\"Password\" /></td><td><input type=\"password\" name=\"password\" size=\"30\"  value=\"$_SESSION[password]\" $userpass/></td></tr>\n";
	echo "<tr><td></td>";
	echo "<td><input type=\"image\" name=\"submit\" value=\"connect\" alt=\"connect\" src=\"files/tango_icons/connect.png\"  class=\"submit\" /></td></tr></table>\n";
	echo "</form>";
	echo "</div>";
	}
	else
// ------------------- Logged in ---------------------------------------------------------------------------------------------
	{
	echo "<div id=\"content\">\n";

	$ftpstream = @ftp_connect($ftp_server);						// Connect to server
	if ($ftpstream)
		{										// Server correct
		$login = @ftp_login($ftpstream, $_SESSION['user'], $_SESSION['password']);	// Login
		if($login)
			{
			// ---------- List Files  ----------------------------------------------------------------------
			echo "<form action=\"#\" method=\"POST\">\n";
			echo "<table>\n";
			echo "<tr>\n";
			echo "<td><h1>myFtpWebEdit</h1></td>\n";
			echo "<td><img src=\"files/tango_icons/edit.png\" alt=\"Edit\" class=\"icon\"/></td>";
			echo "<td><select name=\"file\" size=\"1\" onchange=\"this.form.submit();\">\n";
			echo "<option value=\"none\">Choose / Choisir / W&auml;hlen / Elegir</option>\n";
			$filelist=ftp_nlist($ftpstream ,  $ftp_folder);		// List folder
			sort($filelist);						// Alphabetical sort
			foreach ($filelist as $key => $value)
				{ echo "<option value=\"$value\">$value</option>\n";}

			echo "</select>\n</td>";
			echo "<td><a href=\"?logout\"><img src=\"files/tango_icons/quit.png\" alt=\"Quit\" /></a></td>\n";
			echo "<td><a href=\"http://www.bracher-automation.com/en/myftpwebedit.php\" target=\"new\"><img src=\"files/tango_icons/about.png\" alt=\"About\" /></a></td>\n";
			echo "</tr></table></form>\n";

			// ---------- Save Text-File  ----------------------------------------------------------------------
			if (isset($_POST['textcontent']))
				{
				$temp = tmpfile();
				fseek($temp, 0);					// Go to file start
				fwrite($temp, $_POST['textcontent']);			// Write string to temporary file
				fseek($temp, 0);					// Go to file start
				if (ftp_fput($ftpstream, "$_POST[file]", $temp, FTP_ASCII, 0)) 
					{
					} 
				}
			
			// ---------- Save CSV File  ----------------------------------------------------------------------
			if (isset($_POST['csvfile']))
				{
				$temp = tmpfile();						// Create temporary file
				fseek($temp, 0);						// Go to file start
				$linearray=array();
				$counter=0;
				foreach($_POST as $key => $value)
					{
					if (is_numeric($key))
						{
						$value=htmlconf($value);
						array_push($linearray, $value);
						$counter++;
						if ($counter>=$_POST['itemcount'])
							{
							fputcsv($temp, $linearray, "\t");
							$linearray=array();
							$counter=0;
							}
						}
					}
				fseek($temp, 0);		
				ftp_fput($ftpstream, $_POST['csvfile'], $temp, FTP_ASCII);	// Put file on server
				}
			
			if (isset($_POST['file']))
				{
				// ----------- Text File Editor --------------------------------------------------------
				if (strpos($_POST['file'], ".txt")!==FALSE)
					{
					echo "<br/><form action=\"\" method=\"POST\">\n";
					echo "<input type=\"hidden\" name=\"file\" value=\"$_POST[file]\"/>";
					echo "<table><tr>";
					echo "<th><img src=\"files/tango_icons/textfile.png\" alt=\"Edit\" class=\"icon\"/></th>";
					echo "<th>TinyMCE Editor</th>";
					echo "<th>$_POST[file]</th></tr>\n";
				
					$temp = tmpfile();
					if (@ftp_fget($ftpstream, $temp, "$_POST[file]", FTP_ASCII, 0)) 
						{
						rewind($temp);
						echo "<tr><td colspan=\"3\"><textarea name=\"textcontent\" rows=\"20\" cols=\"60\">";
        					echo stream_get_contents($temp);
						echo "</textarea></td></tr>\n";
						}  
					echo "</table>\n";
					echo "\n</form>\n";
					}

				// ---------- CSV FILE Editor --------------------------------------------------------
				if (strpos($_POST['file'], ".csv")!==FALSE)
					{
					echo "<br/><form action=\"\" method=\"POST\">\n";
					echo "<input type=\"hidden\" name=\"file\" value=\"$_POST[file]\"/>";
					$file=str_replace($ftp_root, "../",  $_POST['file']);			// Replace ftp root with file-system root
					echo "<table id=\"csv_file\">\n";
					echo "<tr>";
					echo "<th><img src=\"files/tango_icons/textfile.png\" alt=\"Edit\" class=\"icon\"/></th>";
					echo "<th>CSV-File Editor</th>";
					echo "<th>$_POST[file]</th></tr>\n";
					$datei= fopen($file, "r");						// Opening the File
					if (!($datei==FALSE))							// If opening was successful
						{
						$item=0;
						$itemcount=0;
						$rownr=0;
						$linenr=0;
						while (!(feof($datei)))						// Until File is finished
							{
							echo "<tr>";
							$line=fgetcsv($datei, 10000, "\t");
							if ($line!==FALSE)
								{
								foreach($line as $key => $value) 		// For each result
									{
									echo "<td><input type=\"input\" name=\"$item\" value=\"$value\" size=\"25\"";
									if (($rownr==0)OR($linenr==0)) {echo ' readonly="readonly"';}
									echo " id=\"$item\" onchange=\"this.form.submit();\" class=\"noborder\"/></td>";
									$item++;
									$linenr++;
									}
								}
							echo "</tr>";
							$rownr++;
							$linenr=0;
							if ($itemcount==0) {$itemcount=$item;}			// Number of items per line
							}
						}
					@fclose($datei); // Close
					echo "<tr><td colspan=\"3\"></td></tr><input type=\"hidden\" name=\"itemcount\" value=\"$itemcount\">\n";
					echo "<input type=\"hidden\" name=\"csvfile\" value=\"$_POST[file]\">\n";
					echo "</table><br/></form>";
					}
				


				}			
			}
		@ftp_close($ftpstream);	
		}
	echo "</div>";
	}
?>
<p id="footnote">A Web-Application by <a href="http://www.bracher-automation.com">Bracher-Automation</a></p>
</body>
</html>